library angular2.src.forms.directives;

import "package:angular2/src/facade/lang.dart" show Type;
import "directives/control_name_directive.dart" show ControlNameDirective;
import "directives/form_control_directive.dart" show FormControlDirective;
import "directives/ng_model_directive.dart" show NgModelDirective;
import "directives/control_group_directive.dart" show ControlGroupDirective;
import "directives/form_model_directive.dart" show FormModelDirective;
import "directives/template_driven_form_directive.dart"
    show TemplateDrivenFormDirective;
import "directives/default_value_accessor.dart" show DefaultValueAccessor;
import "directives/checkbox_value_accessor.dart"
    show CheckboxControlValueAccessor;
import "directives/select_control_value_accessor.dart"
    show SelectControlValueAccessor;
export "directives/control_name_directive.dart" show ControlNameDirective;
export "directives/form_control_directive.dart" show FormControlDirective;
export "directives/ng_model_directive.dart" show NgModelDirective;
export "directives/control_directive.dart" show ControlDirective;
export "directives/control_group_directive.dart" show ControlGroupDirective;
export "directives/form_model_directive.dart" show FormModelDirective;
export "directives/template_driven_form_directive.dart"
    show TemplateDrivenFormDirective;
export "directives/control_value_accessor.dart" show ControlValueAccessor;
export "directives/default_value_accessor.dart" show DefaultValueAccessor;
export "directives/checkbox_value_accessor.dart"
    show CheckboxControlValueAccessor;
export "directives/select_control_value_accessor.dart"
    show SelectControlValueAccessor;

/**
 *
 * A list of all the form directives used as part of a `@View` annotation.
 *
 *  This is a shorthand for importing them each individually.
 *
 * @exportedAs angular2/forms
 */
const List<Type> formDirectives = const [
  ControlNameDirective,
  ControlGroupDirective,
  FormControlDirective,
  NgModelDirective,
  FormModelDirective,
  TemplateDrivenFormDirective,
  DefaultValueAccessor,
  CheckboxControlValueAccessor,
  SelectControlValueAccessor
];
