library angular2.src.forms.directives.ng_model_directive;

import "package:angular2/src/facade/async.dart"
    show EventEmitter, ObservableWrapper;
import "package:angular2/src/facade/collection.dart" show StringMapWrapper;
import "package:angular2/angular2.dart" show Directive, Ancestor, onChange;
import "package:angular2/di.dart" show Binding;
import "control_directive.dart" show ControlDirective;
import "../model.dart" show Control;
import "shared.dart" show setUpControl;

const formControlBinding =
    const Binding(ControlDirective, toAlias: NgModelDirective);
@Directive(
    selector: "[ng-model]:not([ng-control]):not([ng-form-control])",
    hostInjector: const [formControlBinding],
    properties: const ["model: ng-model"],
    events: const ["ngModel"],
    lifecycle: const [onChange])
class NgModelDirective extends ControlDirective {
  Control control;
  EventEmitter ngModel;
  dynamic model;
  bool _added;
  NgModelDirective() : super() {
    /* super call moved to initializer */;
    this.control = new Control("");
    this.ngModel = new EventEmitter();
    this._added = false;
  }
  onChange(c) {
    if (!this._added) {
      setUpControl(this.control, this);
      this.control.updateValidity();
      this._added = true;
    }
    ;
    if (StringMapWrapper.contains(c, "model")) {
      this.control.updateValue(this.model);
    }
  }
  List<String> get path {
    return [];
  }
  void viewToModelUpdate(dynamic newValue) {
    ObservableWrapper.callNext(this.ngModel, newValue);
  }
}
