library angular2.src.forms.directives.shared;

import "package:angular2/src/facade/collection.dart" show ListWrapper;
import "package:angular2/src/facade/lang.dart" show isBlank, BaseException;
import "control_container_directive.dart" show ControlContainerDirective;
import "control_directive.dart" show ControlDirective;
import "../model.dart" show Control;
import "../validators.dart" show Validators;

controlPath(name, ControlContainerDirective parent) {
  var p = ListWrapper.clone(parent.path);
  ListWrapper.push(p, name);
  return p;
}
setUpControl(Control c, ControlDirective dir) {
  if (isBlank(c)) _throwError(dir, "Cannot find control");
  if (isBlank(dir.valueAccessor)) _throwError(dir, "No value accessor for");
  c.validator = Validators.compose([c.validator, dir.validator]);
  dir.valueAccessor.writeValue(c.value);
  // view -> model
  dir.valueAccessor.registerOnChange((newValue) {
    dir.viewToModelUpdate(newValue);
    c.updateValue(newValue);
    c.markAsDirty();
  });
  // model -> view
  c.registerOnChange((newValue) => dir.valueAccessor.writeValue(newValue));
  // touched
  dir.valueAccessor.registerOnTouched(() => c.markAsTouched());
}
void _throwError(ControlDirective dir, String message) {
  var path = ListWrapper.join(dir.path, " -> ");
  throw new BaseException('''${ message} \'${ path}\'''');
}
