library angular2.test.change_detection.simple_watch_config;

import "package:angular2/src/facade/collection.dart" show ListWrapper;
import "package:angular2/change_detection.dart"
    show BindingRecord, ChangeDetectorDefinition, Lexer, Parser;
import "package:angular2/src/reflection/reflection.dart" show reflector;
import "package:angular2/src/reflection/reflection_capabilities.dart"
    show ReflectionCapabilities;

var _parser = new Parser(new Lexer());
ChangeDetectorDefinition _createChangeDetectorDefinition(
    String id, String propName, String expression) {
  reflector.reflectionCapabilities = new ReflectionCapabilities();
  var ast = _parser.parseBinding(expression, "location");
  var bindingRecords = [BindingRecord.createForElement(ast, 0, propName)];
  var strategy = null;
  var variableBindings = [];
  var directiveRecords = [];
  return new ChangeDetectorDefinition(
      id, strategy, variableBindings, bindingRecords, directiveRecords);
}
/**
 * In this case, we expect `id` and `expression` to be the same string.
 */
ChangeDetectorDefinition getDefinition(String id, String propName) {
  // TODO(kegluneq): Remove `propName`?
  if (ListWrapper.indexOf(_availableDefinitions, id) < 0) {
    throw '''No ChangeDetectorDefinition for ${ id} available. Please modify this file if necessary.''';
  }
  return _createChangeDetectorDefinition(id, propName, id);
}
/**
 * Get all available ChangeDetectorDefinition objects. Used to pre-generate Dart
 * `ChangeDetector` classes.
 */
List<ChangeDetectorDefinition> getAllDefinitions(String propName) {
  return ListWrapper.map(
      _availableDefinitions, (id) => getDefinition(id, propName));
}
var _availableDefinitions = [
  "10",
  "\"str\"",
  "\"a\n\nb\"",
  "10 + 2",
  "10 - 2",
  "10 * 2",
  "10 / 2",
  "11 % 2",
  "1 == 1",
  "1 != 1",
  "1 == true",
  "1 === 1",
  "1 !== 1",
  "1 === true",
  "1 < 2",
  "2 < 1",
  "1 > 2",
  "2 > 1",
  "1 <= 2",
  "2 <= 2",
  "2 <= 1",
  "2 >= 1",
  "2 >= 2",
  "1 >= 2",
  "true && true",
  "true && false",
  "true || false",
  "false || false",
  "!true",
  "!!true",
  "1 < 2 ? 1 : 2",
  "1 > 2 ? 1 : 2",
  "[\"foo\", \"bar\"][0]",
  "{\"foo\": \"bar\"}[\"foo\"]",
  "value",
  "a",
  "address.city",
  "address?.city",
  "address?.toString()",
  "sayHi(\"Jim\")",
  "a()(99)",
  "a.sayHi(\"Jim\")"
];
