library angular2.test.core.directive_lifecycle_integration_spec;

import "package:angular2/test_lib.dart"
    show
        AsyncTestCompleter,
        beforeEach,
        ddescribe,
        describe,
        expect,
        iit,
        inject,
        it,
        xdescribe,
        xit,
        IS_DARTIUM;
import "package:angular2/src/facade/collection.dart" show ListWrapper;
import "package:angular2/src/test_lib/test_bed.dart" show TestBed;
import "package:angular2/angular2.dart"
    show Directive, Component, View, onCheck, onInit, onChange;
import "package:angular2/src/core/annotations_impl/view.dart" as viewAnn;

main() {
  describe("directive lifecycle integration spec", () {
    var ctx;
    beforeEach(() {
      ctx = new MyComp();
    });
    it("should invoke lifecycle methods onChanges > onInit > onCheck", inject([
      TestBed,
      AsyncTestCompleter
    ], (tb, async) {
      tb.overrideView(MyComp, new viewAnn.View(
          template: "<div [field]=\"123\" [lifecycle]></div>",
          directives: [LifecycleDir]));
      tb.createView(MyComp, context: ctx).then((view) {
        var dir = view.rawView.elementInjectors[0].get(LifecycleDir);
        view.detectChanges();
        expect(dir.log).toEqual(["onChanges", "onInit", "onCheck"]);
        view.detectChanges();
        expect(dir.log).toEqual(["onChanges", "onInit", "onCheck", "onCheck"]);
        async.done();
      });
    }));
  });
}
@Directive(
    selector: "[lifecycle]",
    properties: const ["field"],
    lifecycle: const [onChange, onCheck, onInit])
class LifecycleDir {
  var field;
  List<String> log;
  LifecycleDir() {
    this.log = [];
  }
  onChange(_) {
    ListWrapper.push(this.log, "onChanges");
  }
  onInit() {
    ListWrapper.push(this.log, "onInit");
  }
  onCheck() {
    ListWrapper.push(this.log, "onCheck");
  }
}
@Component(selector: "my-comp")
@View(directives: const [])
class MyComp {}
